#ifndef _OS_MESSAGEQ_H
#define _OS_MESSAGEQ_H

typedef struct _QMessage QMSG;

struct _QMessage{
	u_char	id;
	int		param;
	void*	data;
};

typedef struct _MessageQueue MessageQueue;

struct _MessageQueue{
	HANDLE			event_wait; //Wait for a message
	MessageQueue*	p_next;
	u_char			read;
	u_char			write;
	u_char			mask;
	QMSG			que[0];
};

typedef struct _MessageQueue* QHANDLE;

QHANDLE		  MQ_Allocate(u_char len);
int			  MQ_Broadcast(u_char id,int param,void* data);
int			  MQ_Post(QHANDLE q,u_char id,int param,void* data);
int			  MQ_Send(QHANDLE q,u_char id,int param,void* data);
int			  MQ_GetMessage(QHANDLE que, QMSG* msg,u_long timeout);
int			  MQ_Full(QHANDLE que);

extern MessageQueue* pMessageQueue;

#endif

